/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using UnityEngine;using System.Collections.Generic;namespace PluginIdea.NavgatePlay{public class HangoutMode : NavgateModeBase{private JSONStorableFloat minStayDur, maxStayDur;private JSONStorableFloat width, height, offsetX, offsetZ;private JSONStorableBool isDrawHangoutSquare;private Vector3 lastTargetPos;private Color squareColor = new Color(0, 0.8f, 0, 0.1f);private Vector3 CenterPos{get{return new Vector3(offsetX.val, 0.1f, offsetZ.val);}}public HangoutMode(NavgatePlay ower){this.ower = ower;}public override void Init(){Utils.SetupSpacer(ower, 20, false);Utils.SetupInfoTextNoScroll(ower, Location.GetStr(Location.HangOutModeSubTitle), 35, false);minStayDur = Utils.SetupSliderFloat(ower, Location.GetStr(Location.MinStayTimeWithHangout), 1f, 0f, 10f, false);maxStayDur = Utils.SetupSliderFloat(ower, Location.GetStr(Location.MaxStayTimeWithHangout), 5f, 0f, 25, false);isDrawHangoutSquare = Utils.SetupToggle(ower, Location.GetStr(Location.IsDrawHangoutSqure), false, false);width = Utils.SetupSliderFloat(ower, Location.GetStr(Location.HangOutSquareAreaWidth), 5f, 1f, 25f, false);height = Utils.SetupSliderFloat(ower, Location.GetStr(Location.HangOutSquareAreaHeight), 5f, 1f, 25f, false);offsetX = Utils.SetupSliderFloat(ower, Location.GetStr(Location.CenterOffsetX), 0f, -25f, 25f, false);offsetZ = Utils.SetupSliderFloat(ower, Location.GetStr(Location.CenterOffsetZ), 0f, -25f, 25f, false);}public override void OnEnter(){ower.CurrentAnimator.gameObject.SetActive(true);ower.SetBoolParamValue("animatorEnabledJSON", true);ower.HudHander.HUDStr = Location.GetStr(Location.HUD_HangOutMode);ower.SetCurrentAnimation(ower.IdleAnim, false, 0);ower.CurrentMoveState = MoveState.IDLE;StayAndHangOut();}public override void OnExit(){}public override void OnUpdate(){}public void StayAndHangOut(){ower.TimerMgr.RemoveAllTimer();ower.TimerMgr.AddTimer(Random.Range(minStayDur.val, maxStayDur.val), () =>{Vector3 tpos = Vector3.zero;GetAValidTargetPos(ref tpos);ower.MoveToTargetPoint(tpos);lastTargetPos = tpos;});}private void GetAValidTargetPos(ref Vector3 tpos){float x = Random.Range(CenterPos.x - width.val / 2f, CenterPos.x + width.val / 2f);float z = Random.Range(CenterPos.z - height.val / 2f, CenterPos.z + height.val / 2f);Vector3 targetPos = new Vector3(x, 0, z);if (Vector3.Distance(targetPos, lastTargetPos) > 1.3f){tpos = targetPos;}else{GetAValidTargetPos(ref tpos);}}public override void OnPostRender(){base.OnPostRender();if (isDrawHangoutSquare.val){Vector3 ld = CenterPos + new Vector3(-width.val / 2f, 0, -height.val / 2);Vector3 lu = CenterPos + new Vector3(-width.val / 2f, 0, height.val / 2);Vector3 ru = CenterPos + new Vector3(width.val / 2f, 0, height.val / 2);Vector3 rd = CenterPos + new Vector3(width.val / 2f, 0, -height.val / 2);GLDrawHelper.DrawQuad3D(new List<GLQuad3D>{new GLQuad3D(){color = squareColor, ld = ld, lu = lu, ru = ru, rd = rd}});}}public override void UnInit(){}}}