/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using UnityEngine;using System.Collections.Generic;using System.Linq;using UnityEngine.UI;using System;using Random = UnityEngine.Random;using UnityEngine.EventSystems;using System.Text;using SimpleJSON;using Battlehub.RTCommon;namespace PluginIdea.NavgatePlay{struct PlayMode{public const int ControllerEditMode = 1;public const int AnimationMove = 2;public const int Possession = 3;public const int HangOutMode = 4;public const int FollowAtomMode = 5;public const int KeyBoardControl = 6;public const int FindPathMode = 7;public const int KeyPointMode = 8;}struct MoveState{public const int NONE = 1;public const int TWIST = 2;public const int MOVE = 3;public const int IDLE = 4;}public class NavgatePlay : MVRScript, IGL{class TargetPointInfo{public Vector3 targetPosition;}const string PLAYMODE = "playMode";private JSONStorableBool isShowMarkText;public JSONStorableBool isShowTargetMark;private JSONStorableBool isSaveCurrentPlayMode;private JSONStorableFloat comeHereStopDistance;private JSONStorableFloat commonStopDistance;private JSONStorableBool isAutoEnterEditModeOnWalkFinished;private JSONStorableBool isForceChangeToNavgateMode;private JSONStorableBool isShowWalkPathGizmos;private JSONStorableStringChooser groundChooser;private JSONStorableString saveStr;public JSONStorableAction comeHereAction;public JSONStorableAction goThereAction;public JSONStorableAction nextPointAction;public JSONStorableAction switchToEditModeAction;public JSONStorableAction switchToHanoutModeAction;public JSONStorableAction switchToKeyboardControlModeAction;public JSONStorableAction switchToNavgateModeAction;public Action OnMoveFinished;private Dictionary<string, AnimationSequenceClip> dic_anims = new Dictionary<string, AnimationSequenceClip>();private List<AnimationSequenceClip> idles = new List<AnimationSequenceClip>{new AnimationSequenceClip("Catwalk Heels - Idle", true, 0.5f),};private Animator currentAnimator;private Camera targetCamera;private Transform hipTrans;private TimerManager timerMgr;private PathDrawer pathDrawer;private HudHander hudHander;private KeybordControlMode keybordControlMode;private FollowMode followMode;private NavgateMode navgateMode;private KeyPointMode keyPointMode;private FindPathMode findPathMode;private HangoutMode hangoutMode;private EditMode editMode;private CameraHook cameraHook;private NavgateModeBase lastNavgateMode;private GameObject hitball;private float stopDistance = 1.3f;private int pathPointIndex;private int currentState;private int currentPlayMode = PlayMode.ControllerEditMode;private List<string> atomsChooserList = new List<string>();private List<AnimationClip> tmpClips = new List<AnimationClip>();private UnityAnimatorControl animatorControl;private bool isFree = true;private FreeControllerV3 headControl;private Transform HitBall{get{if (hitball == null){hitball = GameObject.CreatePrimitive(PrimitiveType.Sphere);hitball.GetComponent<Collider>().enabled = false;hitball.transform.localScale = Vector3.one * 0.05f;}return hitball.transform;}}private Transform RightHandTrans{get{if (SuperController.singleton.isOpenVR){return SuperController.singleton.viveObjectRight;}return SuperController.singleton.touchObjectRight;}}public FreeControllerV3 HeadController{get{return this.headControl;}}public Transform CenterCameraTrans{get{if (SuperController.singleton.isOpenVR){return SuperController.singleton.ViveCenterCamera.transform;}return SuperController.singleton.OVRCenterCamera.transform;}}public Animator CurrentAnimator{get{return this.currentAnimator;}}public HudHander HudHander{get{return this.hudHander;}}public string TargetGroundAtomUid{get{return groundChooser.val;}}public float StopDistance{get{return stopDistance;}}public int CurrentMoveState{get{return this.currentState;}set{this.currentState = value;}}public AnimationSequenceClip IdleAnim{get{return idles[Random.Range(0, idles.Count)];}}public TimerManager TimerMgr{get{return this.timerMgr;}}public Dictionary<string, AnimationSequenceClip> Dic_Anims{get{return this.dic_anims;}}private void Start(){if (Utils.IsInVR()){cameraHook = Utils.GetSafeComponent<CameraHook>(CenterCameraTrans.gameObject);cameraHook.onPostRenderCallback += OnPostRender;}else{if (GLRenderer.Instance == null){new GameObject{name = "GLRenderer"}.AddComponent<GLRenderer>();}GLRenderer.Instance.Add(this);}}public override void Init(){Utils.OnInitUI(CreateUIElement);if (isFree){var btn = Utils.SetupButton(this, Location.GetStr(Location.OpenMainPage), () =>{if (Location.IsChinease) Application.OpenURL(@"https:\/\/afdian.net/p/6f6685ceae9211ed8c8952540025c377");else Application.OpenURL(@"https:\/\/www.patreon.com/PluginIdea/about");}, false);btn.buttonImage.color = Color.yellow;Utils.SetupSpacer(this, 30, false);}timerMgr = new TimerManager();hudHander = new HudHander();pathDrawer = new PathDrawer();followMode = new FollowMode(this);navgateMode = new NavgateMode(this);hangoutMode = new HangoutMode(this);keyPointMode = new KeyPointMode(this);keybordControlMode = new KeybordControlMode(this);editMode = new EditMode(this);currentAnimator = containingAtom.reParentObject.Find("object/rescaleObject/g2female").GetComponentInChildren<Animator>();if (currentAnimator == null) currentAnimator = containingAtom.reParentObject.Find("object/rescaleObject/g2male").GetComponentInChildren<Animator>();animatorControl = GameObject.FindObjectOfType<UnityAnimatorControl>();hipTrans = containingAtom.transform.Find("rescale2/PhysicsModel/Genesis2Female/hip");targetCamera = SuperController.singleton.MonitorCenterCamera;containingAtom.freeControllers.ToList().ForEach(c =>{if (c.name == "headControl") headControl = c;});dic_anims.Add("TwistR2L", new AnimationSequenceClip("Catwalk Heels - Twist R to Twist L", true, 0.5f));dic_anims.Add("TwistL2R", new AnimationSequenceClip("Catwalk Heels - Twist L to Twist R", true, 0.5f));dic_anims.Add("BackForwardL", new AnimationSequenceClip("Catwalk Heels - Walk Start Turn 180 Left", true, 0.5f));dic_anims.Add("BackForwardR", new AnimationSequenceClip("Catwalk Heels - Walk Start Turn 180 Right", true, 0.5f));dic_anims.Add("WalkForward", new AnimationSequenceClip("Catwalk Heels - Walk Forward", true, 0.5f));dic_anims.Add("WalkStop", new AnimationSequenceClip("Catwalk Heels - Walk Stop", true, 0.5f));Utils.SetupInfoTextNoScroll(this, Location.GetStr(Location.CommonParameters), 35, false);isShowMarkText = Utils.SetupToggle(this, Location.GetStr(Location.IsShowMarkText), true, false);isShowMarkText.setCallbackFunction = (val) =>{if (val){hudHander.Init(this);}else{hudHander.UnInit();}};Utils.SetupButton(this, Location.GetStr(Location.RefreshAtomList), () =>{RefreshAtomChooserItems();}, false);groundChooser = Utils.SetupStringChooser(this, Location.GetStr(Location.Ground), new List<string>(), false);RefreshAtomChooserItems();isShowTargetMark = Utils.SetupToggle(this, Location.GetStr(Location.IsShowTargetMark), true, false);isSaveCurrentPlayMode = Utils.SetupToggle(this, Location.GetStr(Location.IsSaveCurrentPlayMode), true, false);isShowWalkPathGizmos = Utils.SetupToggle(this, Location.GetStr(Location.IsShowWalkPathGizmos), true, false);comeHereStopDistance = Utils.SetupSliderFloat(this, Location.GetStr(Location.CommeHereStopDistance), 2f, 0f, 10f, false);isAutoEnterEditModeOnWalkFinished = Utils.SetupToggle(this, Location.GetStr(Location.IsAutoEnterEditModeOnWalkFinished), false, false);isForceChangeToNavgateMode = Utils.SetupToggle(this, Location.GetStr(Location.IsForceChangeToNavgateMode), false, false);commonStopDistance = Utils.SetupSliderFloat(this, Location.GetStr(Location.CommonStopDistance), 1.3f, 0f, 10f, false);saveStr = Utils.SetupStorableString(this, "SaveStr", "0");Utils.SetupInfoText(this, Location.GetStr(Location.PluginInfo), 300, true);Utils.SetupSpacer(this, 30, false);Utils.SetupButton(this, Location.GetStr(Location.SwitchNavgatePlayMode), () =>{SwitchToNavegateMode();}, false);Utils.SetupButton(this, Location.GetStr(Location.SwitchToEditMode), () =>{SwithToEditMode();}, false);Utils.SetupButton(this, Location.GetStr(Location.SwitchToFollowMode), () =>{SwitchFollowMode();}, false);Utils.SetupButton(this, Location.GetStr(Location.KeyboardControlMode), () =>{SwitchToKeyboardControlMode();}, false);Utils.SetupButton(this, Location.GetStr(Location.ToHangOutMode), () =>{SwitchToHangOutMode();}, false);Utils.SetupButton(this, Location.GetStr(Location.ToKeyPointMode), () =>{SwitchToKeyPointMode();}, false);hangoutMode.Init();keyPointMode.Init();pathDrawer.Init(this, RightHandTrans);keybordControlMode.Init();followMode.Init();comeHereAction = Utils.SetupAction(this, Location.GetStr(Location.ComeBackHere), () =>{Vector3 point = new Vector3(CenterCameraTrans.position.x, 0, CenterCameraTrans.position.z);stopDistance = comeHereStopDistance.val;MoveToTargetPoint(point, stopDistance);});goThereAction = Utils.SetupAction(this, Location.GetStr(Location.GoThere), () =>{Ray ray = new Ray(RightHandTrans.position, RightHandTrans.forward);Vector3 v3 = Vector3.zero;if (Utils.GetRayHitPoint(ray, ref v3)){stopDistance = commonStopDistance.val;MoveToTargetPoint(v3, stopDistance);}});nextPointAction = Utils.SetupAction(this, Location.GetStr(Location.ToNextPoint), () =>{if (pathDrawer.LinePoints.Count < 2) return;Vector3 point = pathDrawer.LinePoints[pathPointIndex];stopDistance = commonStopDistance.val;MoveToTargetPoint(point, stopDistance);pathPointIndex++;if (pathPointIndex == pathDrawer.LinePoints.Count)                    pathPointIndex = 0;});switchToEditModeAction = Utils.SetupAction(this, Location.GetStr(Location.SwitchEditMode), () =>{SwithToEditMode();});switchToNavgateModeAction = Utils.SetupAction(this, Location.GetStr(Location.SwitchToNavgateMode), () =>{SwitchToNavegateMode();});switchToHanoutModeAction = Utils.SetupAction(this, Location.GetStr(Location.SwitchToHangoutMode), () =>{SwitchToHangOutMode();});switchToHanoutModeAction = Utils.SetupAction(this, Location.GetStr(Location.SwitchToKeyPointMode), () =>{SwitchToKeyPointMode();});switchToKeyboardControlModeAction = Utils.SetupAction(this, Location.GetStr(Location.SwitchToKeyboardControlMode), () =>{SwitchToKeyboardControlMode();});switchToKeyboardControlModeAction = Utils.SetupAction(this, Location.GetStr(Location.SwitchToFollowMode), () =>{SwitchFollowMode();});hudHander.Init(this);navgateMode.Init();editMode.Init();SwitchToNavegateMode();InitEvent();}private void InitEvent(){SuperController.singleton.BroadcastMessage("OnActionsProviderAvailable", this, SendMessageOptions.DontRequireReceiver);SuperController.singleton.onBeforeSceneSaveHandlers += OnBeforeSceneSave;SuperController.singleton.onSceneLoadedHandlers += OnSceneLoaded;}private void UnInitEvent(){SuperController.singleton.onBeforeSceneSaveHandlers -= OnBeforeSceneSave;SuperController.singleton.onSceneLoadedHandlers -= OnSceneLoaded;SuperController.singleton.BroadcastMessage("OnActionsProviderDestroyed", this, SendMessageOptions.DontRequireReceiver);}private void OnSceneLoaded(){SuperController.singleton.StartCoroutine(Utils.WaitTimeCall(1f, () =>{containingAtom.ResetPhysics(true, false);}));try{JSONNode jsonNode = JSONClass.Parse(saveStr.val);if (jsonNode == null) return;JSONArray jarr = jsonNode.AsArray;if (jarr.Count > 0){int playmode = int.Parse(jarr[0][PLAYMODE]);if (playmode == PlayMode.ControllerEditMode){SwithToEditMode();}else{SwitchToNavegateMode();}}}catch (Exception e){SuperController.LogError(e.Message);throw;}}private void OnBeforeSceneSave(){JSONArray array = new JSONArray();JSONClass temp = new JSONClass();temp[PLAYMODE] = currentPlayMode.ToString();array.Add(temp);saveStr.val = array.ToString();}private void SwitchToFindPathMode(){currentPlayMode = PlayMode.FindPathMode;if (lastNavgateMode != null) lastNavgateMode.OnExit();findPathMode.OnEnter();lastNavgateMode = findPathMode;}private void SwitchToHangOutMode(){currentPlayMode = PlayMode.HangOutMode;if (lastNavgateMode != null) lastNavgateMode.OnExit();hangoutMode.OnEnter();lastNavgateMode = hangoutMode;}private void SwitchToKeyPointMode(){currentPlayMode = PlayMode.KeyPointMode;if (lastNavgateMode != null) lastNavgateMode.OnExit();keyPointMode.OnEnter();lastNavgateMode = keyPointMode;}private void SwithToEditMode(){currentPlayMode = PlayMode.ControllerEditMode;if (lastNavgateMode != null) lastNavgateMode.OnExit();editMode.OnEnter();lastNavgateMode = editMode;}private void SwitchFollowMode(){currentPlayMode = PlayMode.FollowAtomMode;if (lastNavgateMode != null) lastNavgateMode.OnExit();followMode.OnEnter();lastNavgateMode = followMode;}private void SwitchToNavegateMode(){currentPlayMode = PlayMode.AnimationMove;if (lastNavgateMode != null) lastNavgateMode.OnExit();navgateMode.OnEnter();lastNavgateMode = navgateMode;}private void SwitchToKeyboardControlMode(){currentPlayMode = PlayMode.KeyBoardControl;if (lastNavgateMode != null) lastNavgateMode.OnExit();keybordControlMode.OnEnter();lastNavgateMode = keybordControlMode;}private void RefreshAtomChooserItems(){atomsChooserList.Clear();SuperController.singleton.GetAtoms().ToList().ForEach(atom =>{atomsChooserList.Add(atom.uid);});if (atomsChooserList.Count > 0){groundChooser.choices = atomsChooserList;groundChooser.val = atomsChooserList[0];}}Vector3 start, end;Plane currentTargetPlane;float hangoutTimer;private void Update(){lastNavgateMode.OnUpdate();if (currentPlayMode == PlayMode.AnimationMove || isForceChangeToNavgateMode.val){if (!pathDrawer.IsDrawingPath){Vector3 v3 = Vector3.zero;Ray ray;if (Utils.IsInVR()){Vector3 rightHandPosition = RightHandTrans.position;ray = new Ray(rightHandPosition, RightHandTrans.forward);if (Utils.GetRayHitPoint(ray, ref v3, groundChooser.val)){HitBall.position = v3;HitBall.gameObject.SetActive(true);if (SuperController.singleton.GetRightGrabRelease()){stopDistance = commonStopDistance.val;MoveToTargetPoint(v3, stopDistance);}}else{HitBall.gameObject.SetActive(false);}}else{if (Input.GetMouseButtonDown(0) && !EventSystem.current.IsPointerOverGameObject()){ray = SuperController.singleton.MonitorCenterCamera.ScreenPointToRay(Input.mousePosition);if (Utils.GetRayHitPoint(ray, ref v3, groundChooser.val)){stopDistance = commonStopDistance.val;MoveToTargetPoint(v3, stopDistance);}}}}}CheckPauseAction();timerMgr.Update();MoveFinishedCheck();pathDrawer.OnUpdate();keybordControlMode.OnUpdate();}private void FixedUpdate(){TurnUpdate();}private void LateUpdate(){}private Quaternion targetRot, beginRot, delta;private void TurnUpdate(){if (currentTargetPointInfo == null) return;if (currentPlayMode != PlayMode.ControllerEditMode && currentPlayMode != PlayMode.KeyBoardControl && currentState != MoveState.TWIST){beginRot = currentAnimator.transform.rotation;delta = Quaternion.identity;Vector3 offset = currentTargetPointInfo.targetPosition - hipTrans.position;Vector3 forward = new Vector3(hipTrans.forward.x, 0, hipTrans.forward.z).normalized;Vector3 dir = new Vector3(offset.x, 0, offset.z).normalized;targetRot = Quaternion.FromToRotation(forward, dir);delta = Quaternion.Lerp(delta, targetRot, 0.05f);currentAnimator.transform.rotation = beginRot * delta;}}private void CheckPauseAction(){if (Input.GetKeyDown(KeyCode.Space) || Input.GetKeyDown(KeyCode.Keypad0)){SetCurrentAnimation(IdleAnim, false, 0);currentState = MoveState.IDLE;}}private TargetPointInfo currentTargetPointInfo;public void MoveToTargetPoint(Vector3 targetPoint, float stopCheckDistance = -1){if (currentTargetPointInfo == null){currentTargetPointInfo = new TargetPointInfo(){targetPosition = targetPoint};}else{currentTargetPointInfo.targetPosition = targetPoint;}Vector3 offset = targetPoint - hipTrans.position;this.stopDistance = stopCheckDistance == -1?commonStopDistance.val : stopCheckDistance;start = targetPoint;end = hipTrans.position;MoveToTargetWithRootMotion(targetPoint, offset.normalized);}private void MoveToTargetWithRootMotion(Vector3 targetPosition, Vector3 dirction){if (isForceChangeToNavgateMode.val){SwitchToNavegateMode();}Vector3 forward = new Vector3(hipTrans.forward.x, 0, hipTrans.forward.z).normalized;Vector3 dir = new Vector3(dirction.x, 0, dirction.z).normalized;Vector3 crossVec = Vector3.Cross(forward, dir);float angle = Vector3.Angle(forward, dir);currentTargetPlane = new Plane(-dirction, targetPosition);if (angle < 90){if (crossVec.y > 0){SetCurrentAnimation(dic_anims["TwistL2R"], false, 1 - angle / 90);currentState = MoveState.TWIST;timerMgr.AddTimer(1f, () =>{SetCurrentAnimation(dic_anims["WalkForward"], false, 0);currentState = MoveState.MOVE;});}else{SetCurrentAnimation(dic_anims["TwistR2L"], false, 1 - angle / 90);currentState = MoveState.TWIST;timerMgr.AddTimer(1f, () =>{SetCurrentAnimation(dic_anims["WalkForward"], false, 0);currentState = MoveState.MOVE;});}}else{if (crossVec.y > 0){SetCurrentAnimation(dic_anims["BackForwardL"], false, 1.25f - angle / 180);currentState = MoveState.TWIST;timerMgr.AddTimer(1.25f, () =>{SetCurrentAnimation(dic_anims["WalkForward"], false, 0);currentState = MoveState.MOVE;});}else{SetCurrentAnimation(dic_anims["BackForwardR"], false, 1.25f - angle / 180);currentState = MoveState.TWIST;timerMgr.AddTimer(1.25f, () =>{SetCurrentAnimation(dic_anims["WalkForward"], false, 0);currentState = MoveState.MOVE;});}}}private void MoveFinishedCheck(){if (currentState == MoveState.MOVE){if (Mathf.Abs(currentTargetPlane.GetDistanceToPoint(hipTrans.position)) < stopDistance){currentState = MoveState.IDLE;SetCurrentAnimation(IdleAnim, false, 0);RecenterMainController();if (OnMoveFinished != null) OnMoveFinished();if (currentPlayMode == PlayMode.HangOutMode){hangoutMode.StayAndHangOut();}else if (currentPlayMode == PlayMode.KeyPointMode){keyPointMode.StayAndHangOut();}else{if (isAutoEnterEditModeOnWalkFinished.val){timerMgr.AddTimer(0.5f, SwithToEditMode);}}}}}public void SetCurrentAnimation(AnimationSequenceClip animation, bool forceNoCrossFade = false, float fixedTimeOffset = 0f){if (animation != null){animatorControl.SetBoolParamValue("animatorEnabledJSON", true);if (this.currentAnimator != null){this.currentAnimator.speed = 1;this.currentAnimator.CrossFadeInFixedTime(animation.Name, animation.CrossFadeTime, -1, fixedTimeOffset, 0f);}}}public void RecenterMainController(){Atom targetAtom = transform.GetComponentInParent<Atom>();FreeControllerV3 hipControl = null, mainCtr = null;targetAtom.freeControllers.ToList().ForEach(x =>{if (x.name == "hipControl") hipControl = x;if (x.name == "control") mainCtr = x;});Vector3 offset = new Vector3(hipControl.transform.position.x - mainCtr.transform.position.x, 0, hipControl.transform.position.z - mainCtr.transform.position.z);targetAtom.freeControllers.ToList().ForEach(ctr =>{if (ctr.name != mainCtr.name){ctr.transform.position -= offset;}});mainCtr.transform.position += offset;currentAnimator.transform.localPosition = Vector3.zero;}public void OnBindingsListRequested(List<object> bindings){bindings.Add(new JSONStorableAction("To EditMode", SwithToEditMode));bindings.Add(new JSONStorableAction("To NavgateMoveMode", SwitchToNavegateMode));bindings.Add(new JSONStorableAction("To Hangout Mode", SwitchToHangOutMode));bindings.Add(new JSONStorableAction("To KeyPoint Mode", SwitchToKeyPointMode));bindings.Add(new JSONStorableAction("To KeyboardControl Mode", SwitchToKeyboardControlMode));bindings.Add(new JSONStorableAction("To Follow Mode", SwitchFollowMode));}private void OnPostRender(){pathDrawer.OnPostRender();hangoutMode.OnPostRender();if (isShowTargetMark.val && currentPlayMode != PlayMode.KeyBoardControl && currentPlayMode != PlayMode.ControllerEditMode){GLDrawHelper.DrawLine3D(new List<GLLine3D>(){new GLLine3D(){from = start + 0.2f * Vector3.right, to = start - 0.2f * Vector3.right, color = Color.red}}, null);GLDrawHelper.DrawLine3D(new List<GLLine3D>(){new GLLine3D(){from = start + 0.2f * Vector3.forward, to = start - 0.2f * Vector3.forward, color = Color.red}}, null);}}private void OnDestroy(){UnInitEvent();pathDrawer.OnDestroy();hudHander.UnInit();pathDrawer.UnInit();keybordControlMode.UnInit();navgateMode.UnInit();followMode.UnInit();hangoutMode.UnInit();keyPointMode.UnInit();editMode.UnInit();if (hitball != null) Destroy(hitball.gameObject);if (Utils.IsInVR()){Destroy(cameraHook);}else{GLRenderer.Instance.Remove(this);}Utils.OnDestroyUI();}public void Draw(int cullingMask){OnPostRender();}}}