/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using UnityEngine;using System.Collections.Generic;using System.Linq;using System;using SimpleJSON;namespace PluginIdea.NavgatePlay{public class PathDrawer : PLModuleBase{private List<Vector3> linePonts;private List<GameObject> linePointVisualObjects;private Transform rightHandTrans;private JSONStorableBool isShowPathLine;private JSONStorableString saveStr;private bool isDrawingPath;public bool IsDrawingPath{get{return isDrawingPath;}}public List<Vector3> LinePoints{get{return this.linePonts;}}public override void Init(NavgatePlay ower, params object[] args){base.Init(ower, args);linePonts = new List<Vector3>();linePointVisualObjects = new List<GameObject>();rightHandTrans = args[0] as Transform;InitEvent();Utils.SetupInfoTextNoScroll(this.ower, Location.GetStr(Location.CustomPathSubTitle), 35, true);isShowPathLine = Utils.SetupToggle(this.ower, Location.GetStr(Location.IsShowPathLine), true, true);isShowPathLine.setCallbackFunction = (val) =>{linePointVisualObjects.ForEach(o =>{o.SetActive(val);});};saveStr = Utils.SetupStorableString(this.ower, "lines", "");Utils.SetupButton(this.ower, Location.GetStr(Location.UnAdd), () =>{if (linePonts.Count > 0){int index = linePonts.Count - 1;linePonts.RemoveAt(index);var go = linePointVisualObjects[index];linePointVisualObjects.RemoveAt(index);GameObject.Destroy(go);}}, true);Utils.SetupButton(this.ower, Location.GetStr(Location.ClearPath), () =>{ClearLines();}, true);}private void InitEvent(){SuperController.singleton.onBeforeSceneSaveHandlers += OnBeforeSave;SuperController.singleton.onSceneLoadedHandlers += OnSceneLoaded;}private void OnSceneLoaded(){try{JSONNode jsonNode = JSONClass.Parse(saveStr.val);if (jsonNode == null) return;JSONArray jarr = jsonNode.AsArray;if (jarr.Count > 0){ClearLines();for (int i = 0;i < jarr.Count;i++){Vector3 v3 = new Vector3(                            float.Parse(jarr[i]["x"]),                            float.Parse(jarr[i]["y"]),                            float.Parse(jarr[i]["z"])                            );SuperController.LogMessage(v3.ToString());linePonts.Add(v3);}CreateLines(linePonts);}}catch (Exception e){SuperController.LogError(e.Message);throw;}}private void OnBeforeSave(){JSONArray array = new JSONArray();if (linePonts.Count > 0){linePonts.ForEach(linePoint =>{JSONClass temp = new JSONClass();temp["x"] = linePoint.x.ToString();temp["y"] = linePoint.y.ToString();temp["z"] = linePoint.z.ToString();array.Add(temp);});}saveStr.val = array.ToString();SuperController.LogMessage(saveStr.val);}private void UnInitEvent(){SuperController.singleton.onBeforeSceneSaveHandlers -= OnBeforeSave;SuperController.singleton.onSceneLoadedHandlers -= OnSceneLoaded;}public override void OnUpdate(){isDrawingPath = false;if (Input.GetKey(KeyCode.LeftAlt)){isDrawingPath = true;Vector3 v3 = Vector3.zero;Ray ray;if (Utils.IsInVR()){Vector3 rightHandPosition = rightHandTrans.position;ray = new Ray(rightHandPosition, rightHandTrans.forward);if (Utils.GetRayHitPoint(ray, ref v3)){if (SuperController.singleton.GetRightGrabRelease()){linePonts.Add(v3);var go = Utils.CreatePrimimary(PrimitiveType.Sphere, null, new Vector3(0.1f, 0.1f, 0.1f), v3, Quaternion.identity);linePointVisualObjects.Add(go);}}}else{if (Input.GetMouseButtonDown(0)){ray = SuperController.singleton.MonitorCenterCamera.ScreenPointToRay(Input.mousePosition);if (Utils.GetRayHitPoint(ray, ref v3)){linePonts.Add(v3);var go = Utils.CreatePrimimary(PrimitiveType.Sphere, null, new Vector3(0.1f, 0.1f, 0.1f), v3, Quaternion.identity);linePointVisualObjects.Add(go);}}}}}public void ClearLines(){linePonts.Clear();for (int i = 0;i < linePointVisualObjects.Count;i++){GameObject.Destroy(linePointVisualObjects[i]);}linePointVisualObjects.Clear();}private void CreateLines(List<Vector3> line){linePointVisualObjects.Clear();if (line.Count > 0){line.ForEach(p =>{var go = Utils.CreatePrimimary(PrimitiveType.Sphere, null, new Vector3(0.1f, 0.1f, 0.1f), p, Quaternion.identity);linePointVisualObjects.Add(go);});}}public void OnPostRender(){if (isShowPathLine.val && linePonts.Count > 1){List<GLLine3D> lineList = new List<GLLine3D>();for (int i = 0;i <= linePonts.Count - 1;i++){if (i < linePonts.Count - 1){lineList.Add(new GLLine3D{from = linePonts[i], to = linePonts[i + 1], color = Color.green});}else{lineList.Add(new GLLine3D{from = linePonts[i], to = linePonts[0], color = Color.green});}}GLDrawHelper.DrawLine3D(lineList, null);}}public void OnDestroy(){ClearLines();UnInitEvent();}}}